/* tslint:disable */
/* eslint-disable */
/**
 * Scripts
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface StartScriptRequest
 */
export interface StartScriptRequest {
    /**
     * 
     * @type {string}
     * @memberof StartScriptRequest
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof StartScriptRequest
     */
    'transaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof StartScriptRequest
     */
    'language'?: string;
    /**
     * 
     * @type {string}
     * @memberof StartScriptRequest
     */
    'reference'?: string;
    /**
     * 
     * @type {Array<string>}
     * @memberof StartScriptRequest
     */
    'message_tags'?: Array<string>;
    /**
     * 
     * @type {object}
     * @memberof StartScriptRequest
     */
    'static_data'?: object;
    /**
     * 
     * @type {object}
     * @memberof StartScriptRequest
     */
    'dynamic_data'?: object;
    /**
     * 
     * @type {string}
     * @memberof StartScriptRequest
     */
    'interaction_id'?: string;
}

/**
 * ScriptsApi - axios parameter creator
 * @export
 */
export const ScriptsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Start script
         * @summary Start script
         * @param {string} channelId 
         * @param {string} scriptId 
         * @param {StartScriptRequest} [startScriptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        startScript: async (channelId: string, scriptId: string, startScriptRequest?: StartScriptRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('startScript', 'channelId', channelId)
            // verify required parameter 'scriptId' is not null or undefined
            assertParamExists('startScript', 'scriptId', scriptId)
            const localVarPath = `/api/channels/{channel_id}/scripts/{script_id}/start`
                .replace(`{${"channel_id"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"script_id"}}`, encodeURIComponent(String(scriptId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(startScriptRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ScriptsApi - functional programming interface
 * @export
 */
export const ScriptsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ScriptsApiAxiosParamCreator(configuration)
    return {
        /**
         * Start script
         * @summary Start script
         * @param {string} channelId 
         * @param {string} scriptId 
         * @param {StartScriptRequest} [startScriptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async startScript(channelId: string, scriptId: string, startScriptRequest?: StartScriptRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.startScript(channelId, scriptId, startScriptRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ScriptsApi - factory interface
 * @export
 */
export const ScriptsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ScriptsApiFp(configuration)
    return {
        /**
         * Start script
         * @summary Start script
         * @param {string} channelId 
         * @param {string} scriptId 
         * @param {StartScriptRequest} [startScriptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        startScript(channelId: string, scriptId: string, startScriptRequest?: StartScriptRequest, options?: any): AxiosPromise<void> {
            return localVarFp.startScript(channelId, scriptId, startScriptRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ScriptsApi - object-oriented interface
 * @export
 * @class ScriptsApi
 * @extends {BaseAPI}
 */
export class ScriptsApi extends BaseAPI {
    /**
     * Start script
     * @summary Start script
     * @param {string} channelId 
     * @param {string} scriptId 
     * @param {StartScriptRequest} [startScriptRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ScriptsApi
     */
    public startScript(channelId: string, scriptId: string, startScriptRequest?: StartScriptRequest, options?: AxiosRequestConfig) {
        return ScriptsApiFp(this.configuration).startScript(channelId, scriptId, startScriptRequest, options).then((request) => request(this.axios, this.basePath));
    }
}



